{#
/**
 * @file
 * Olivero's theme implementation for the menus in the secondary_menu region.
 *
 * Available variables:
 * - menu_name: The machine name of the menu.
 * - items: A nested list of menu items. Each menu item contains:
 *   - attributes: HTML attributes for the menu item.
 *   - below: The menu item child items.
 *   - title: The menu link title.
 *   - url: The menu link url, instance of \Drupal\Core\Url
 *   - localized_options: Menu link localized options.
 *   - is_expanded: TRUE if the link has visible children within the current
 *     menu tree.
 *   - is_collapsed: TRUE if the link has children within the current menu tree
 *     that are not currently visible.
 *   - in_active_trail: TRUE if the link is in the active trail.
 *
 * @ingroup themeable
 */
#}
{{ attach_library('h4c_olive/navigation-secondary') }}

{% import _self as menus %}

{#
  We call a macro which calls itself to render the full tree.
  @see https://twig.symfony.com/doc/1.x/tags/macro.html
#}
{% set attributes = attributes.addClass('menu') %}
{{ menus.menu_links(items, attributes, 0) }}

{% macro menu_links(items, attributes, menu_level) %}
  {% set secondary_nav_level = 'secondary-nav__menu--level-' ~ (menu_level + 1) %}
  {% import _self as menus %}
  {% if items %}
    <ul{{ attributes.addClass('secondary-nav__menu', secondary_nav_level) }}>
      {% set attributes = attributes.removeClass(secondary_nav_level) %}
      {% for item in items %}

        {% if item.url.isRouted and item.url.routeName == '<nolink>' %}
          {% set menu_item_type = 'nolink' %}
        {% elseif item.url.isRouted and item.url.routeName == '<button>' %}
          {% set menu_item_type = 'button' %}
        {% else %}
          {% set menu_item_type = 'link' %}
        {% endif %}

        {% set item_classes = [
            'secondary-nav__menu-item',
            'secondary-nav__menu-item--' ~ menu_item_type,
            'secondary-nav__menu-item--level-' ~ (menu_level + 1),
            item.in_active_trail ? 'secondary-nav__menu-item--active-trail',
            item.below ? 'secondary-nav__menu-item--has-children',
          ]
        %}

        {% set link_classes = [
            'secondary-nav__menu-link',
            'secondary-nav__menu-link--' ~ menu_item_type,
            'secondary-nav__menu-link--level-' ~ (menu_level + 1),
            item.in_active_trail ? 'secondary-nav__menu-link--active-trail',
            item.below ? 'secondary-nav__menu-link--has-children',
          ]
        %}

        <li{{ item.attributes.addClass(item_classes) }}>
          {{ link(item.title, item.url, { 'class': link_classes }) }}

          {% if item.below %}
            {{ menus.menu_links(item.below, attributes, menu_level + 1) }}
          {% endif %}
        </li>
      {% endfor %}
    </ul>
  {% endif %}
{% endmacro %}
